/*
    This program uses a mutex to avoid the race condition.
*/
#include <stdio.h>   // fprintf(), stderr
#include <stdlib.h>  // exit(), NULL
#include <unistd.h>  // sleep()
#include <pthread.h>

// global variables
int runFlag = 1;
unsigned int count  = 0;  // this variable is shared by thread1 and thread2
unsigned int count1 = 0;  // this variable is used only by thread1
unsigned int count2 = 0;  // this variable is used only by thread2

pthread_mutex_t mutex;

int main( int argc, char *argv[])
{
   void *thread1(void *vargp);  //thread function prototypes
   void *thread2(void *vargp);

   int threadParam1 = 0;  // thread function parameters
   int threadParam2 = 0;

   pthread_t tid1;
   pthread_t tid2;

   // initialize the mutex (in signaled state)
   pthread_mutex_init(&mutex, NULL);

   // create two threads
   printf("race2m: Starting threads\n");
   pthread_create(&tid1, NULL, thread1, &threadParam1);
   pthread_create(&tid2, NULL, thread2, &threadParam2);

   sleep(2);     // let the threads run for a while
   runFlag = 0;  // now stop the threads
   sleep(1);     // give the threads time to stop

   printf("\nThreads stopped.\n");
   printf("count = %d, count1 = %d, count2 = %d\n", count, count1, count2);

   return 0;
}//main


void *thread1(void *vargp)
{
   unsigned int my_count;
   while(runFlag)
   {
      pthread_mutex_lock(&mutex);
      my_count = count++;
      if (count - my_count != 1)
         printf("Bingo1: count - my_count = %d\n", count-my_count);
      pthread_mutex_unlock(&mutex);
      count1++;
   }
   return 0;
}//thread1


void *thread2(void *vargp)
{
   unsigned int my_count;
   while(runFlag)
   {
      pthread_mutex_lock(&mutex);
      my_count = count++;
      if (count - my_count != 1)
         printf("Bingo2: count - my_count = %d\n", count-my_count);
      pthread_mutex_unlock(&mutex);
      count2++;
   }
   return 0;
}//thread2
