/*
    This program uses a (binary) semaphore to avoid the
    race condition.
*/
#include <windows.h>
#include <stdio.h>

// global variables
int runFlag = TRUE;
unsigned int count  = 0;  // this variable is shared by thread1 and thread2
unsigned int count1 = 0;  // this variable is used only by thread1
unsigned int count2 = 0;  // this variable is used only by thread2

HANDLE semaphore;

int main( int argc, char *argv[])
{
   DWORD WINAPI thread1(LPVOID);  //thread function prototypes
   DWORD WINAPI thread2(LPVOID);

   int threadParam1 = 0;  // thread function parameters
   int threadParam2 = 0;

   // create a (binary) Semaphore object
   semaphore = CreateSemaphore(NULL, 1, 1, NULL); // signaled

   // create two threads
   printf("race2s: Starting threads\n");
   CreateThread(NULL, 0, thread1, &threadParam1, 0, NULL);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, NULL);

   Sleep(2000);      // let the threads run for a while
   runFlag = FALSE;  // now stop the threads
   Sleep(20);        // give the threads time to stop

   printf("\nThreads stopped.\n");
   printf("count = %d, count1 = %d, count2 = %d\n", count, count1, count2);

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   unsigned int my_count;
   while(runFlag)
   {
      WaitForSingleObject(semaphore, INFINITE);
      my_count = count++;
      if (count - my_count != 1)
         printf("Bingo1: count - my_count = %d\n", count-my_count);
      ReleaseSemaphore(semaphore, 1, NULL);
      count1++;
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   unsigned int my_count;
   while(runFlag)
   {
      WaitForSingleObject(semaphore, INFINITE);
      my_count = count++;
      if (count - my_count != 1)
         printf("Bingo2: count - my_count = %d\n", count-my_count);
      ReleaseSemaphore(semaphore, 1, NULL);
      count2++;
   }
   return 0;
}//thread2
