/*
    This program uses a (binary) semaphore to avoid the race condition.

    This program uses a binary semaphore implemented using the Pentium
    machine instruction BTS. The semaphore is implemented directly
    in this program. This version of the semaphore is more efficient
    than the previous version because it avoids a busy loop in the wait
    function.
*/
#include <windows.h>
#include <stdio.h>

// global variables
int runFlag = TRUE;
unsigned int count  = 0;  // this variable is shared by thread1 and thread2
unsigned int count1 = 0;  // this variable is used only by thread1
unsigned int count2 = 0;  // this variable is used only by thread2

int* semaphore;

int main( int argc, char *argv[])
{
   DWORD WINAPI thread1(LPVOID);  //thread function prototypes
   DWORD WINAPI thread2(LPVOID);

   int threadParam1 = 0;  // thread function parameters
   int threadParam2 = 0;

   // create a (binary) semaphore
   semaphore = malloc(sizeof(int));
   *semaphore = 0;   // signaled

   // create two threads
   printf("race5se: Starting threads\n");
   CreateThread(NULL, 0, thread1, &threadParam1, 0, NULL);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, NULL);

   Sleep(2000);      // let the threads run for a while
   runFlag = FALSE;  // now stop the threads
   Sleep(20);        // give the threads time to stop

   printf("\nThreads stopped.\n");
   printf("count = %d, count1 = %d, count2 = %d\n", count, count1, count2);

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   unsigned int my_count;
   while(runFlag)
   {
again:  __asm mov eax, semaphore
        __asm bts [eax], 0
        __asm jnc notSet
        Sleep(0);
        __asm jmp again
notSet: my_count = count++;
        if (count - my_count != 1)
           printf("Bingo1: count - my_count = %d\n", count-my_count);
        *semaphore = 0;
        count1++;
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   unsigned int my_count;
   while(runFlag)
   {
again:  __asm mov eax, semaphore
        __asm bts [eax], 0
        __asm jnc notSet
        Sleep(0);
        __asm jmp again
notSet: my_count = count++;
      if (count - my_count != 1)
         printf("Bingo2: count - my_count = %d\n", count-my_count);
      *semaphore = 0;
      count2++;
   }
   return 0;
}//thread2
